#include "Triangle.h"
#include "glut.h"


//--------------------------------------------------------------------------------------------------
//

static size_t UID = -1;
static size_t VID = -1;

void makeModel()
{
	vertexPool.push_back(CVertex(-95.0, 5.0, -30.0));
	vertexPool.push_back(CVertex(-68.0, 55.0, 0.0));
	vertexPool.push_back(CVertex(-10.0, 80.0, -20.0));
	vertexPool.push_back(CVertex(65.0, 60.0, 5.0));
	vertexPool.push_back(CVertex(110.0, 15.0, -5.0));
	vertexPool.push_back(CVertex(85.0, -48.0, 25.0));
	vertexPool.push_back(CVertex(0.0, -65.0, 30.0));
	vertexPool.push_back(CVertex(-72.0, -42.0, 10.0));
	vertexPool.push_back(CVertex(-50.0, -10.0, -10.0));
	UID = vertexPool.size() - 1;
	vertexPool.push_back(CVertex(50.0, 10.0, 10.0));
	VID = vertexPool.size() - 1;

	trianglePool.push_back(CTriangle(0, 8, 1, trianglePool.size()));
	trianglePool.push_back(CTriangle(1, 8, 2, trianglePool.size()));
	trianglePool.push_back(CTriangle(2, 8, 9, trianglePool.size()));
	trianglePool.push_back(CTriangle(2, 9, 3, trianglePool.size()));
	trianglePool.push_back(CTriangle(3, 9, 4, trianglePool.size()));
	trianglePool.push_back(CTriangle(4, 9, 5, trianglePool.size()));
	trianglePool.push_back(CTriangle(5, 9, 6, trianglePool.size()));
	trianglePool.push_back(CTriangle(6, 9, 8, trianglePool.size()));
	trianglePool.push_back(CTriangle(6, 8, 7, trianglePool.size()));
	trianglePool.push_back(CTriangle(7, 8, 0, trianglePool.size()));
}
/*
void makeModel1()
{
	::std::vector<CTriangle> triangles;
	
	triangles.push_back(CTriangle(0, 8, 1, triangles.size()));
	triangles.push_back(CTriangle(1, 8, 2, triangles.size()));
	triangles.push_back(CTriangle(2, 8, 3, triangles.size()));
	triangles.push_back(CTriangle(3, 8, 4, triangles.size()));
	triangles.push_back(CTriangle(4, 8, 5, triangles.size()));
	triangles.push_back(CTriangle(5, 8, 6, triangles.size()));
	triangles.push_back(CTriangle(6, 8, 7, triangles.size()));
	triangles.push_back(CTriangle(7, 8, 0, triangles.size()));

	for (::std::vector<CTriangle>::iterator it = triangles.begin(); it != triangles.end(); ++it)
		it->draw();
}

void makeModel2()
{
	::std::vector<CTriangle> triangles;
	
	triangles.push_back(CTriangle(0, 9, 1, triangles.size()));
	triangles.push_back(CTriangle(1, 9, 2, triangles.size()));
	triangles.push_back(CTriangle(2, 9, 3, triangles.size()));
	triangles.push_back(CTriangle(3, 9, 4, triangles.size()));
	triangles.push_back(CTriangle(4, 9, 5, triangles.size()));
	triangles.push_back(CTriangle(5, 9, 6, triangles.size()));
	triangles.push_back(CTriangle(6, 9, 7, trianglePool.size()));
	triangles.push_back(CTriangle(7, 9, 0, triangles.size()));

	for (::std::vector<CTriangle>::iterator it = triangles.begin(); it != triangles.end(); ++it)
		it->draw();
}
*/
void render(void)
{
	GLfloat matSpecular[] = { 0.5f, 0.5f, 0.5f, 1.0f };
	GLfloat matShininess[] = { 1000.0f };

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glMaterialfv(GL_FRONT, GL_SPECULAR, matSpecular);
	glMaterialfv(GL_FRONT, GL_SHININESS, matShininess);

	//
	glPushMatrix();
		glTranslatef(0.0f, 0.0f, 0.0f);

		for (::std::vector<CTriangle>::iterator it = trianglePool.begin(); it != trianglePool.end(); ++it)
			it->draw();
	glPopMatrix();
/*
	//
	glPushMatrix();
		glTranslatef(-250.0f, 0.0f, 0.0f);
		makeModel1();
	glPopMatrix();

	//
	glPushMatrix();
		glTranslatef(250.0f, 0.0f, 0.0f);
		makeModel2();
	glPopMatrix();
*/
	glFlush();
}

void initialize(void) 
{
	glClearColor(1.0, 1.0, 1.0, 1.0);
	glShadeModel(GL_FLAT);
	
	glEnable(GL_DEPTH_TEST);
	
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	
	GLfloat light_position[] = { -0.5, -0.5, 1.0, 0.0 };
	glLightfv(GL_LIGHT0, GL_POSITION, light_position);

	//
	makeModel();

	double c1 = vertexPool[UID].calcEdgeCollapseCost(vertexPool[VID]);
	double c2 = vertexPool[VID].calcEdgeCollapseCost(vertexPool[UID]);

	::std::cout << '\n';
	::std::cout << "   U  V    Һ: C1 = " << c1 << '\n';
	::std::cout << "   V  U    Һ: C2 = " << c2 << '\n';

	::std::cout << '\n';
	if (c1 < c1)
		::std::cout << "  C1 < C2̹Ƿ  U  V  Ͽ Ѵ\n";
	else
		::std::cout << "  C1 > C2̹Ƿ  V  U  Ͽ Ѵ\n";
}

void reshape(int w, int h)
{
	glViewport(0, 0, (GLsizei)w, (GLsizei)h);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(30.0, double(w) / double(h), 1.0, 2000.0);
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef(0.0f, 0.0f, -500.0f);
}

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize(500, 500); 
	glutInitWindowPosition(100, 100);
	glutCreateWindow("Mesh Simplification");
	
	initialize();
	
	glutDisplayFunc(render); 
	glutReshapeFunc(reshape); 
	//glutIdleFunc(render);
	glutMainLoop();
	
	return 0;
}
