// Frustum.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glaux.h>
#include <gl/glut.h>
#include <math.h>
#include "vector.h"

#define MAP_SIZE			64
#define DEF_RENDER_SPEED	10

CVector g_vOrigin(  -10,  0, -10 );			// eye position
CVector g_vTarget(  0,  0, 50 );			// eye target
CVector g_vTerrain[MAP_SIZE][MAP_SIZE];
GLfloat	g_fov = 30.0f;						// field of view frustum angle
GLfloat	g_angle = 0.0f;						// eye vector ȸ

CVector g_vEye;								// eye vector
CVector	g_vLLine;							// left frustum plane
CVector	g_vLNormal;							// left frustum plane normal
CVector	g_vRLine;							// right frustum plane
CVector	g_vRNormal;							// right frustum plane normal

BOOL	g_bCull = FALSE;					// culling !
BOOL	g_bStop = FALSE;

// Vec  angleŭ ȸϿ pRet  Ѵ.
inline void rotate( float angle, CVector* pVec, CVector* pRet )
{
	float rad = angle * 3.141592f / 180.0f;
	float c = cos( rad );
	float s = sin( rad );

	pRet->x =  pVec->x * c + pVec->z * s;
	pRet->z = -pVec->x * s + pVec->z * c;
}

// view frustum Ѵ.
void calcView()
{
	// view ⺤͸ ؼ g_angleŭ ȸŲ.
	CVector	v, v2;
	v = g_vTarget - g_vOrigin;
	rotate( g_angle, &v, &g_vEye );

	// view ⺤͸ g_fovŭ  ȸ
	rotate(  g_fov, &g_vEye, &g_vRLine );
	// g_fov+90ϸ plane normalͰ ȴ.
	//  ̰ (90 + theta)ȸ̹Ƿ cos, sinĢ   ÿ ѹ Ҽ ִ.
	rotate(  (g_fov + 90.0f), &g_vEye, &g_vRNormal );

	//  ȸ
	rotate( -g_fov, &g_vEye, &g_vLLine );
	rotate( -(g_fov + 90.0f), &g_vEye, &g_vLNormal );
}

void camera()
{
	//  ԵǴ ī޶ 
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
	gluLookAt( 0, 50, -80, 0, 0, 0, 0, 1, 0 );
}

void key( unsigned char key, int x, int y )
{
	switch( key )
	{
		case '1' :				// fov viewing angle
			g_fov -= 5.0f;
			break;
		case '2' :				// fov viewing angle
			g_fov += 5.0f;
			break;				// culling ұ? ?
		case '3' : 
			g_bCull = 1 - g_bCull;
			break;
		case ' ' : 
			g_bStop = !g_bStop;
			break;
	}
}

void mouse( int x, int y )
{
}

BOOL InFrustum( CVector v )		// frustumȿ ִ°?
{
	CVector vtx;
	vtx = v - g_vOrigin;
	if( ( g_vLNormal.x * vtx.x + g_vLNormal.z * vtx.z ) > 0 ) return FALSE; // frustum left frustum plane ̹Ƿ culling out!
	if( ( g_vRNormal.x * vtx.x + g_vRNormal.z * vtx.z ) > 0 ) return FALSE; // frustum right frustum plane ̹Ƿ culling out!

	return TRUE;
}

void drawTerrain( void )
{
	int		x, z;

	glColor3f( 1.0f, 1.0f, 1.0f );
	glBegin( GL_POINTS );
	for( z = 0 ; z < MAP_SIZE ; z++ )
		for( x = 0 ; x < MAP_SIZE ; x++ )
		{
			if( g_bCull )		// cullingΰ?
			{
				if( InFrustum( g_vTerrain[z][x] ) )		// frustumȿ ִ°?
					glVertex3f( g_vTerrain[z][x].x, g_vTerrain[z][x].y, g_vTerrain[z][x].z );
			}
			else
				glVertex3f( g_vTerrain[z][x].x, g_vTerrain[z][x].y, g_vTerrain[z][x].z );
		}

	glEnd();
}

void drawView( void )
{
	CVector	v;

	// red -> view vector 
	glColor3f( 1.0f, 0.0f, 0.0f );
	v.x = g_vOrigin.x + g_vEye.x;
	v.y = g_vOrigin.y + g_vEye.y;
	v.z = g_vOrigin.z + g_vEye.z;
	glBegin( GL_LINES );
		glVertex3f( g_vOrigin.x, g_vOrigin.y, g_vOrigin.z );
		glVertex3f( v.x, v.y, v.z );
	glEnd();

	// blue -> frustum plane
	glColor3f( 0.0f, 0.0f, 1.0f );
	v.x = g_vOrigin.x + g_vLLine.x;
	v.y = g_vOrigin.y + g_vLLine.y;
	v.z = g_vOrigin.z + g_vLLine.z;
	glBegin( GL_LINES );
		glVertex3f( g_vOrigin.x, g_vOrigin.y, g_vOrigin.z );
		glVertex3f( v.x, v.y, v.z );
	glEnd();
	v.x = g_vOrigin.x + g_vRLine.x;
	v.y = g_vOrigin.y + g_vRLine.y;
	v.z = g_vOrigin.z + g_vRLine.z;
	glBegin( GL_LINES );
		glVertex3f( g_vOrigin.x, g_vOrigin.y, g_vOrigin.z );
		glVertex3f( v.x, v.y, v.z );
	glEnd();

	// yellow -> frustum plane normal 
	glColor3f( 1.0f, 1.0f, 0.0f );
	v.x = g_vOrigin.x + g_vLNormal.x;
	v.y = g_vOrigin.y + g_vLNormal.y;
	v.z = g_vOrigin.z + g_vLNormal.z;
	glBegin( GL_LINES );
		glVertex3f( g_vOrigin.x,  g_vOrigin.y,  g_vOrigin.z );
		glVertex3f( v.x, v.y, v.z );
	glEnd();
	v.x = g_vOrigin.x + g_vRNormal.x;
	v.y = g_vOrigin.y + g_vRNormal.y;
	v.z = g_vOrigin.z + g_vRNormal.z;
	glBegin( GL_LINES );
		glVertex3f( g_vOrigin.x,  g_vOrigin.y,  g_vOrigin.z );
		glVertex3f( v.x, v.y, v.z );
	glEnd();

}

void render( void )
{
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	if( !g_bStop ) g_angle += 0.5f;
	drawTerrain();
	drawView();

	glutSwapBuffers();
}

void idle( void )
{
	static int nPrevTick = 0;
	int nCurrTick = GetTickCount();
	camera();
	calcView();

	if( nCurrTick - nPrevTick > DEF_RENDER_SPEED )
	{
		render();
		nPrevTick = nCurrTick;
	}
}

void initTerrain()
{
	int			x, z;
	CVector		v;

	for( z = 0 ; z < MAP_SIZE ; z++ )
		for( x = 0 ; x < MAP_SIZE ; x++ )
		{
			v.x = x - MAP_SIZE / 2;
			v.z = z - MAP_SIZE / 2;
			v.y = 0.0f;
			g_vTerrain[z][x] = v;
		}
}

void initGL( int argc, char* argv[] )
{
	glutInit( &argc, argv );
	glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );
	glutInitWindowPosition( 100, 100 );
	glutInitWindowSize( 640, 480 );
	glutCreateWindow( "Frustum Cull" );
	glutDisplayFunc( render );
	glutPassiveMotionFunc( mouse );
	glutIdleFunc( idle );
	glutKeyboardFunc( key );

	glShadeModel( GL_SMOOTH );
	glEnable(GL_DEPTH_TEST);
	glPointSize( (GLfloat)1.0f );
	glPolygonMode( GL_FRONT_AND_BACK, GL_POINT );
	glFrontFace( GL_CCW );

	glViewport( 0, 0, 640, 480 );
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	gluPerspective( 45, (GLfloat)640 / (GLfloat)480, 1.0f, 2000.0f );

	glClearColor( 0.0, 0.0, 0.0, 0.0 );
}

int main(int argc, char* argv[])
{
	initGL( argc, argv );
	initTerrain();
	printf( "[]\n := ü\nǪ := frustum plane\n := frustum plane normal\n" );
	printf( "[]\nŰ1 := FOV  \nŰ2 := FOV  \nŰ3 := Culling on/off\n̽ := \n" );
	glutMainLoop();
	return 0;
}

